package landlordApp;

import java.io.OutputStream;
import java.io.PrintStream;
import java.util.Random;

/**
 * Vastuualueet:
 * -Tietää talolle vaaditut kentät
 * -Osaa tarkastaa tietyn kentän oikeellisuuden
 *  eli syntakstin.
 * -Osaa muuttaa talo tiedot tiedostosta talon
 *  tiedoiksi
 * -Osaa antaa merkkijonona i:n kentän tiedot
 * -Osaa laittaa merkkijonon i:neksi kentäksi
 * @author Nico & Eelis
 * @version 12.3.2020
 *
 */
public class Talo {
	
	//Attribuutit

	private int id;
	private String osoite;
	private String paikkakunta;
	private int postinro;
	private int rakennusvuosi;
	
	private static Random rand;
	private static int seuraavaNro = 1;
	
	
	/**
	 * Rekisteroi uuden talon ja kasvattaa talojen lukumäärää yhdellä.
	 * @return 
	 * @example
	 * <pre name="test">
	 * Talo talo = new Talo();
	 * talo.getId() === 0;
	 * talo.rekisteroi();
	 * Talo talo2 = new Talo();
	 * talo2.rekisteroi();
	 * int n1 = talo.getId();
	 * int n2 = talo2.getId();
	 * n1 === n2-1;
	 * </pre>
	 */
	public int rekisteroi() {
		this.id = seuraavaNro;
		Talo.seuraavaNro++;
		return id;
		
	}
	
	
	/**
	 * Palauttaa talon id:n
	 * @return talon id
	 */
	public int getId() {
		return this.id;
	}
	
	
	/**
	 * Täyttää talon tiedot oletustiedoilla testaamista varten.
	 */
	public void taytaOletus() {
		rand = new Random();
		
		osoite = "Taitoniekantie 9b";
		paikkakunta = "Jyväskylä";
		postinro = 40740 + rand.nextInt(100);
		rakennusvuosi = 1975;
	}
	
	
	/**
	 * Tulostaa talon tiedot.
	 * @param out tietovirta johon tulostetaan.
	 */
	public void tulosta(PrintStream out) {
		out.println(id);
		out.println(osoite + " " + postinro + " " + paikkakunta);
		out.println(rakennusvuosi + "\n");
	}
	
	
	/**
	 * Tulostetaan talon tiedot
	 * @param os tietovirta johon tulostetaan.
	 */
	public void tulosta(OutputStream os) {
		tulosta(new PrintStream(os));
	}
	

	/**
	 * @param args ei käytössä
	 */
	public static void main(String[] args) {
		Talo koti = new Talo();
		Talo koti2 = new Talo();
		
		koti.rekisteroi();
		koti2.rekisteroi();
		
		koti.taytaOletus();
		koti2.taytaOletus();
		
		koti.tulosta(System.out);
		koti2.tulosta(System.out);
		
	}

/**
 * Palauttaa osoitteen
 * @return osoite
 */
	public String getOsoite() {
		
		return osoite;
	}
	
	
}
